BISON(1)

NAME
bison - GNU Project parser generator (yacc replacement)

SYNOPSIS
bison [ -b file-prefix ] [ --file-prefix=file-prefix ] [ -d ] [ --defines ] [ -H hairy_parser ] [ -L bison_library ] [ -k ] [ --token-table ] [ -l ] [ --no-lines ] [ -n ] [ --no-parser ] [ -o outfile ] [ --output-file=outfile ] [ -p prefix ] [ --name-prefix=prefix ] [ -r ] [ --raw ] [ -S simple_parser ] [ -t ] [ --debug ] [ -v ] [ --verbose ] [ -V ] [ --version ] [ -y ] [ --yacc ] [ -h ] [ --help ] [ --fixed-output-files ] file

DESCRIPTION
Bison is a parser generator in the style of yacc(1). It should be upwardly compatible with input files designed for yacc.

Input files should follow the yacc convention of ending in .y. Unlike yacc, the generated files do not have fixed names, but instead use the prefix of the input file. For instance, a grammar description file named parse.y would produce the generated parser in a file named parse.tab.c, instead of yacc's y.tab.c.

This description of the options that can be given to bison is adapted from the node Invocation in the bison.texinfo manual, which should be taken as authoritative.

Bison supports both traditional single-letter options and mnemonic long option names. Long option names are indicated with -- instead of -. Abbreviations for option names are allowed as long as they are unique. When a long option takes an argument, like --file-prefix, connect the option name and the argument with =.

  OPTIONS

-b file-prefix

--file-prefix=file-prefix
    Specify a prefix to use for all bison output file names. The names are chosen as if the input file were named file-prefix.c.

-d

--defines
    Write an extra output file containing macro definitions for the token type names defined in the grammar and the semantic value type YYSTYPE, as well as a few extern variable declarations.

    If the parser output file is named name.c then this file is named name.h.

    This output file is essential if you wish to put the definition of yylex in a separate source file, because yylex needs to be able to refer to token type codes and the variable yylval.

-H hairy_parser

--hairy-parser=hairy_parser
    Take the hairy parser skeleton from hairy_parser instead of any environment variable or default.

-L libdir

--library=libdir
    Take the library directory name from libdir instead of any environment variable or default.

-r

--raw
    The token numbers in the name.h file are usually the Yacc compatible translations. If this switch is specified, Bison token numbers are output instead. (Yacc numbers start at 257 except for single character tokens; Bison assigns token numbers sequentially for all tokens starting at 3.)

-k

--token-table
    This switch causes the name.tab.c output to include a list of token names in order by their token numbers; this is defined in the array yytname. Also generated are #defines for YYNTOKENS, YYNNTS, YYNRULES, and YYNSTATES.

-l

--no-lines
    Don't put any #line preprocessor commands in the parser file. Ordinarily bison puts them in the parser file so that the C compiler and debuggers will associate errors with your source file, the grammar file. This option causes them to associate errors with the parser file, treating it an independent source file in its own right.

-n

--no-parser
    Do not generate the parser code into the output; generate only declarations. The generated name.tab.c file will have only constant declarations. In addition, a name.act file is generated containing a switch statement body containing all the translated actions.

-o outfile

--output-file=outfile
    Specify the name outfile for the parser file.

    The other output files' names are constructed from outfile as described under the -v and -d switches.

-p prefix

--name-prefix=prefix
    Rename the external symbols used in the parser so that they start with prefix instead of yy. The precise list of symbols renamed is yyparse, yylex, yyerror, yylval, yychar, and yydebug.

    For example, if you use -p c, the names become cparse, clex, and so on.

-S simple_parser

+simple-parser=simple_parser
    Take the simple parser skeleton from simple_parser instead of any environment variable or default.

-t

--debug
    Output a definition of the macro YYDEBUG into the parser file, so that the debugging facilities are compiled.

-v

--verbose
    Write an extra output file containing verbose descriptions of the parser states and what is done for each type of look-ahead token in that state.

    This file also describes all the conflicts, both those resolved by operator precedence and the unresolved ones.

    The file's name is made by removing .tab.c or .c from the parser output file name, and adding .output instead.

    Therefore, if the input file is foo.y, then the parser file is called foo.tab.c by default. As a consequence, the verbose output file is called foo.output.

-V

--version
    Print the version number of bison and exit.

-h

--help
    Print a summary of the options to bison and exit.

-y

--yacc

--fixed-output-files
    Equivalent to -o y.tab.c; the parser output file is called y.tab.c, and the other outputs are called y.output and y.tab.h. The purpose of this switch is to imitate yacc's output file name conventions. Thus, the following shell script can substitute for yacc:

    bison -y $*

Bison requires two parser skeleton files to be available in order to generate output. These two files are the "simple" and "hairy" versions of the parser skeleton. Ordinarily their locations are compiled into bison by default and the user need not be concerned.

The combinations of environment variables and command line options to bison are somewhat confusing. The actual rules used are as follows:

    If -S is specified on the command line, it's argument is the fully qualified name of the "bison.simple" parser skeleton.

    If -H is specified on the command line, it's arg is the fully qualified name of the "bison.hairy" parser skeleton.

    If no -S command line option, then if the BISON_SIMPLE environment variable exists, it's value is the fully qualified name of the "bison.simple" parser skeleton.

    If no -H command line option, then if the BISON_HAIRY environment variable exists, it's value is the fully qualified name of the "bison.hairy" parser skeleton.

    if -L is specified on the command line, then we look for XPFILE and XPFILE1 in the directory it names.

    If no -L command line option, then if the BISONLIB environment variable exists, it's value names the directory in which we look for XPFILE and XPFILE1.

    If no -L command line option, and no BISONLIB environment variable, then we look in XPLIB.

    XPFILE defaults to "bison.simple".

    XPFILE defaults to "bison.hairy".

    XPLIB defaults to /usr/local/lib.

XPFILE, XPFILE1, and XPLIB are compile time options to bison. That is, they are normally set in the bison Makefile prior to building the bison binary.

ENVIRONMENT
If the environment variable BISON_SIMPLE is defined, then it's value is the fully qualified pathname of the parser file to use for simple parsers. The default is "/usr/local/lib/bison.simple".

If the environment variable BISON_HAIRY is defined, then it's value is the fully qualified pathname of the parser file to use for simple parsers. The default is "/usr/local/lib/bison.hairy".

If the environment variable BISONLIB is defined, then it's value is the fully qualified pathname of the directory in which to look for the parser skeletons. The default is "/usr/local/lib".

The long-named options can be introduced with `+' as well as `--', for compatibility with previous releases. Eventually support for `+' will be removed, because it is incompatible with the POSIX.2 standard.

FILES
/usr/local/lib/bison.simple    simple parser
/usr/local/lib/bison.hairy    complicated parser

SEE ALSO
yacc(1)
The Bison Reference Manual, included as the file bison.texinfo in the bison source distribution.

BUGS
The arcane approach to command line options and environment variables is necessary to support previous user interfaces and to allow the "simple" and "hairy" parser skeletons to live in different directories.

DIAGNOSTICS
Self explanatory.